﻿using System;

namespace Luticate2.Utils.Interfaces
{
    public interface ILuNotificationsBusiness
    {
        void Notify(string eventName, string entityType, object oldEntity, object newEntity,
            Func<string, bool> filter = null);

        void NotifyCreate(string entityType, object newEntity, Func<string, bool> filter = null);

        void NotifyUpdate(string entityType, object oldEntity, object newEntity,
            Func<string, bool> filter = null);

        void NotifyDelete(string entityType, object oldEntity, Func<string, bool> filter = null);
    }
}