﻿using Luticate2.Utils.Business;
using TestUtils.DataAccess;
using TestUtils.Dbo.PkGuid;

namespace WebApiUtils.Business
{
    public class PkGuidBusiness : LuCrudBusiness<LuUtilsPkGuidDataAccess, PkGuidAddDbo, PkGuidDbo, PkGuidAddDbo, string>
    {
        public PkGuidBusiness(LuUtilsPkGuidDataAccess dataAccess, LuNotificationsBusiness notificationsBusiness) : base(dataAccess, notificationsBusiness)
        {
            EntityType = "pkguid";
        }
    }
}