﻿using Luticate2.Auth.Business;
using Luticate2.Utils.Controllers;
using Luticate2.Utils.Dbo.Basic;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Options;

namespace Luticate2.Auth.Controllers
{
    [Route("luticate/groups")]
    public class LuGroupsController : LuController
    {
        private readonly LuGroupsBusiness _luGroupsBusiness;

        public LuGroupsController(LuGroupsBusiness luGroupsBusiness, IOptions<LuUtilsOptionsDbo> luUtilsOptionsDbo) : base(luUtilsOptionsDbo)
        {
            _luGroupsBusiness = luGroupsBusiness;
        }

        public string Get()
        {
            return _luGroupsBusiness.Get();
        }
    }
}